<!---
<fusedoc fuse="act_getcircuitstruct.cfm" version="2.0" language="ColdFusion">
	<responsibilities>
		I get the circuits structure from the fbx_Circuits file in the
		specified directory and return it.
	</responsibilities>
	<io>
		<in>
			<string name="rootdir" scope="attributes" />
		</in>
		<out>
			<struct name="circuits" comments="the specified directory's circuit structure" />
		</out>
	</io>
	<throws type="TempFileUncreatableException" />
</fusedoc>
--->

<cfscript>
	for (i = 0; i LTE 10; i = i + 1) {
		tempfile = removeChars(rand(), 2, 1) & chr(randRange(97, 122)) & request.app.tempfileExtension;
		if (NOT fileExists(request.app.basedir & tempfile))
			break;
	}
</cfscript>

<cfif fileExists(request.app.basedir & tempfile)>
	<cfthrow type="TempFileUncreatableException"
		message="The parser was unable to find a suitable filename for it's internal temp file."
		detail="The temp file is created in the same directory as the parser, and is composed of several random numbers followd by a random lowercase letter followed by '#request.app.tempfileExtension#'.  If you have any such files in your directory, please delete them.  If that doesn't fix the issue, please ensure that the ColdFusion Server's user account has write access to the local directory." />
</cfif>

<!--- get the circuit list by indirectly including the app's fbx_Circuits file --->
<cflock name="#tempfile#" type="exclusive" timeout="10">
	<cffile action="copy"
		source="#attributes.rootdir##request.os.delimiter#fbx_Circuits.cfm"
		destination="#request.app.basedir##tempfile#"
		mode="664"
		attributes="normal" />
</cflock>

<cfset fusebox.circuits_bak = duplicate(fusebox.circuits) />

<cfinclude template="#tempfile#" />

<cfset circuits = duplicate(fusebox.circuits) />
<cfset fusebox.circuits = duplicate(fusebox.circuits_bak) />
<cfset structDelete(fusebox, "circuits_bak") />

<cflock name="#tempfile#" type="exclusive" timeout="10">
	<cffile action="delete"
		file="#request.app.basedir##tempfile#" />
</cflock>
