<!---
<fusedoc fuse="FBX_Switch.cfm">
	<responsibilities>
		I am the cfswitch statement that handles the fuseaction, delegating work to various fuses.
	</responsibilities>
	<io>
		<string name="fusebox.fuseaction" />
		<string name="fusebox.circuit" />
	</io>	
</fusedoc>
--->
<cfswitch expression = "#fusebox.fuseaction#">
    
	<cfcase value="home,fusebox.defaultfuseaction">
		<cfset xfa.submit = fusebox.targetcircuit & ".generate" />
		<cfinclude template="frm_fusedocer.cfm" />
	</cfcase>
	
	<cfcase value="generate">
		<!--- include functions --->
		<cfinclude template="udf_processcircuit.cfm" />
		<cfinclude template="udf_processfile.cfm" />
		<cfinclude template="udf_processfbx_Switch.cfm" />
		<cfinclude template="udf_writefuse.cfm" />
		<cfinclude template="udf_pathformat.cfm" />
		
		<!--- read in the static data files --->
		<cfinclude template="act_getxsl.cfm" />
		<cfinclude template="act_gethtml.cfm" />
		<cfinclude template="act_getcss.cfm" />
		
		<!--- do the needed validation and prep work --->
		<cfinclude template="val_fusedocer.cfm" />
		<cfinclude template="act_getcircuitstruct.cfm" />
		
		<!--- do the application parse --->
		<cfinclude template="act_parse.cfm" />
		<cfoutput><hr />Parse Complete<hr /></cfoutput>
		
		<!--- do the documentation generation --->
		<cfinclude template="act_generate.cfm" />
		<cfoutput><hr />Generation Complete<hr /></cfoutput>
	</cfcase>
	
	<cfdefaultcase>
		<cfthrow type="InvalidFuseactionException"
			message="The fuseaction you requested (#fusebox.fuseaction#) is invalid in this circuit (#fusebox.targetcircuit#)" />
	</cfdefaultcase>

</cfswitch>
