<!---
<fusedoc fuse="udf_pathformat.cfm" version="2.0" language="ColdFusion">
	<responsibilities>
		I return a formatted text representation of the specified fuse
		within the circuit hierarchy.
	</responsibilities>
	<io>
		<in>
			<string name="fuse" scope="arguments" />
			<string name="path" scope="arguments" />
			<number name="level" scope="arguments" optional="true" default="1" />
		</in>
		<out>
			<string name="_unknown_" comments="the formatted fuse path" />
		</out>
	</io>
</fusedoc>
--->

<cffunction name="pathFormat" returntype="string">
	<cfargument name="fuse" type="string" />
	<cfargument name="path" type="string" />
	<cfargument name="level" type="numeric" required="false" default="1" />

	<cfset prefix = listFirst(path, request.os.delimiter) & chr(10) &
			"#repeatString('&nbsp;', level * 4)#|" & chr(10) &
			"#repeatString('&nbsp;', level * 4)#+--" />

	<cfif listLen(path, request.os.delimiter) GT 1>
		<cfreturn prefix & pathFormat(fuse, listRest(path, request.os.delimiter), level + 1) />
	<cfelse>
		<cfreturn prefix & fuse />
	</cfif>
</cffunction>