<!---
<fusedoc fuse="udf_processcircuit.cfm" version="2.0" language="ColdFusion">
	<responsibilities>
		I process a circuit's fuses and fuseactions into their
		intermediate representation.
	</responsibilities>
	<io>
		<in>
			<string name="dir" scope="arguments" />
		</in>
		<out>
			<structure name="_unknown_" comments="the intermediate representation of the circuit">
				<structure name="coreFiles" />
				<structure name="fuses" />
				<structure name="fuseactions" />
			</structure>
		</out>
	</io>
</fusedoc>
--->

<cffunction name="processCircuit" returnType="struct">
	<cfargument name="dir" type="string" required="true" />

	<cfset var s = structNew() />
	<cfset var filecontent = "" />

	<cfdirectory action="list"
		directory="#dir#"
		name="files"
		filter="#request.app.fusefilter#" />

	<!--- loop the fuses and get their information --->
	<cfoutput query="files">
		<cfif type EQ "file">
			&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; Parsing #name#...<br>
			<cfset fusetype = iif(left(name, len(request.app.corefilePrefix)) EQ request.app.corefilePrefix, de("coreFiles"), de("fuses")) />
			<cfif NOT structKeyExists(s, fusetype)>
				<cfset structInsert(s, fusetype, structNew()) />
			</cfif>
			<cfset structInsert(s[fusetype], name, processFile("#dir##request.os.delimiter##name#")) />
		</cfif>
	</cfoutput>

	<cfif fileExists("#dir#/fbx_Switch.cfm")>
		<cfset s.fuseactions = processfbx_Switch("#dir#/fbx_Switch.cfm") />
	</cfif>

	<cfreturn s />
</cffunction>
