<!---
<fusedoc fuse="udf_processfbx_Switch.cfm" version="2.0" language="ColdFusion">
	<responsibilities>
		I process a fbx_Switch file and return an intermediate
		represenation of it's relevant contents
	</responsibilities>
	<io>
		<in>
			<string name="filename" scope="arguments" />
		</in>
		<out>
			<structure name="_unknown_" comments="the intermediate representation of the fbx_Switch file" />
		</out>
	</io>
</fusedoc>
--->

<cffunction name="processfbx_Switch" returntype="struct">
	<cfargument name="filename" type="string" />

	<cfset var s = structNew() />
	<cfset var cases = arrayNew(1) />
	<cfset var fuseactions = "" />
	<cfset var start = 0 />
	<cfset var end = 0 />
	<cfset var i = 0 />
	
	<cffile action="read"
		file="#filename#"
		variable="filecontent" />
			
	<cfscript>
		while (findNoCase("<cfcase", fileContent, start) GT 0) {
			start = findNoCase("<cfcase", fileContent, start) + 1;
			end = find(">", filecontent, start);
			arrayAppend(cases, mid(filecontent, start, end - start));
		}

		for (i = 1; i LTE arrayLen(cases); i = i + 1) {
			start = findOneOf("""'", cases[i]);
			cases[i] = removeChars(cases[i], 1, start);
			start = findOneOf("""'", cases[i]);
			fuseactions = listAppend(fuseactions, left(cases[i], start - 1));
		}
		
		if (findNoCase("<cfdefaultcase", filecontent))
			fuseactions = listAppend(fuseactions, "cfdefaultcase");
	</cfscript>

	<cfloop list="#fuseactions#" index="fa">
		<cfset structInsert(s, fa, "")>
	</cfloop>

	<cfreturn s>
</cffunction>