<!---
<fusedoc fuse="udf_writefuse.cfm" version="2.0" language="ColdFusion">
	<responsibilities>
	</responsibilities>
	<io>
		<in>
			<string name="fuse" scope="arguments" />
			<string name="fusefile" scope="arguments" />
			<string name="path" scope="arguments" />
			<string name="fusedoc" scope="arguments" />
		</in>
		<out>
		</out>
	</io>
</fusedoc>
--->

<cffunction name="writefuse" returntype="void">
	<cfargument name="fuse" type="string" />
	<cfargument name="fusefile" type="string" />
	<cfargument name="path" type="string" />
	<cfargument name="fusedoc" type="string" />

	<cfset var summary = "" />
	<cfset var detail = "" />
	<cfset var temp = "" />
	
	<cftry>
		<cfif isXMLDoc(arguments.fusedoc)>
			<cfset summary = xmlTransform(arguments.fusedoc, request.xsl.summary) />
			<cfset detail = xmlTransform(arguments.fusedoc, request.xsl.detail) />
		<cfelse>
			<cfset summary = "<i>The extracted fusedoc was invalid</i>" />
			<cfset detail = "" />
		</cfif>
		<cfcatch>
			<cfset summary = "<i>An error occured while running the XSL Transformation on the fusedoc</i>" />
			<cfset detail = "" />
			<cfoutput><span class="error">#path#/#fuse# : error running XSL Transformation</span><br /></cfoutput>
		</cfcatch>
	</cftry>
	
	<cfset temp = replace(request.html.doc_open, "<!rootpath!>", repeatString("../", listLen(path, "/"))) & chr(10) &
		replace(request.html.fuse_header, "<!rootpath!>", repeatString("../", listLen(path, "/"))) & chr(10) &
		"<h1>#fuse#</h1>" & chr(10) &
		"<pre>&nbsp;&nbsp;/" & pathFormat(fuse, path) & "</pre>" & chr(10) &
		summary & chr(10) &
		detail & chr(10) &
		replace(request.html.fuse_header, "<!rootpath!>", repeatString("../'", listLen(path, "/"))) & chr(10) &
		request.html.doc_close />

	<cffile action="write"
		file="#attributes.outputdir#/#path#/#fusefile#"
		output="#temp#"
		addnewline="0"
		mode="664" />
	
	<cfreturn />
</cffunction>